import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;

import javax.swing.JList;
import javax.swing.SwingUtilities;
import javax.swing.event.MouseInputAdapter;

class dragSelectionListener extends MouseInputAdapter 
{
    Point lastPoint = null;
    public void mousePressed(MouseEvent e) 
    {
        lastPoint = e.getPoint();     // Need to hold onto starting mousepress location...
    }
    public void mouseReleased(MouseEvent e)
    {
        lastPoint = null;
    }
    public void mouseDragged (MouseEvent e)
    {
        JList list = (JList)e.getSource();
        if (lastPoint != null && !e.isConsumed () && SwingUtilities.isLeftMouseButton(e) && ! e.isShiftDown ())
        {
        	int row = list.locationToIndex(e.getPoint());
        	if (row != -1)
        	{
        		int leadIndex = list.locationToIndex(lastPoint);
        		// System.out.println("drag on row: "+row+" leadIndex:"+leadIndex);
        		
        		if (row != leadIndex)
        		{ // ignore drag within row
        			Rectangle cellBounds = list.getCellBounds(row, row);
        			if (cellBounds != null) 
        			{
        				list.scrollRectToVisible(cellBounds);
        				
        				// Cannot use getAnchorSelectionIndex cause keeps getting reset to current row..
        				//  jfc suggested code had:  int anchorIndex = list.getAnchorSelectionIndex ();
        				
        				int anchorIndex = leadIndex;
        				if (e.isControlDown ()) 
        				{
        					if (list.isSelectedIndex (anchorIndex))
        					{ // add selection
        						list.removeSelectionInterval (anchorIndex, leadIndex);
        						list.addSelectionInterval (anchorIndex, row);
        					}
        					else
        					{
        						// remove selection
        						list.addSelectionInterval (anchorIndex, leadIndex);
        						list.removeSelectionInterval (anchorIndex, row);
        					}
        				}
        				else
        				{ // replace selection
        					list.setSelectionInterval (leadIndex, row);
        				}
        			}
        		}
        	}
        }
    }
}
